'
' Stereo SID example
' 

CON _clkmode = xtal1 + pll16x
    _xinfreq = 5_000_000    
    SD_PINS  = 0
    AUDIO_R  = 10
    AUDIO_L  = 11
    playRate = 50'Hz
    detune   = 1.006
                        
VAR
  byte  buffer[25]
  long  A

OBJ
  SID1 : "SIDCog"
  SID2 : "SIDCog"
  SD   : "fsrw" 
  
PUB Main 
  
  SID1.start(AUDIO_R,0)                 ' Start one SID to the right
  waitcnt(cnt+(clkfreq>>8))             ' Need a little pause for some reason???
  A := SID2.start(AUDIO_L,0)            ' Start another SID to the left and store SID address
 
  sd.mount(SD_PINS)                     ' Mount SD card  
  sd.popen(string("Giana.dmp"),"r")  ' Open the tune
              
  repeat
    waitcnt(cnt+(clkfreq/playRate))     ' Wait one VBL
    sd.pread(@buffer,25)                ' Read 25 bytes from SD card
    SID1.updateRegisters(@buffer)       ' Update SID1
    SID2.updateRegisters(@buffer)       ' Update SID2

    ' Detune the SID to the left slightly    
    word[A+0 ] := (word[A+0 ]<<16)/trunc(65536.0/detune)
    word[A+8 ] := (word[A+8 ]<<16)/trunc(65536.0/detune)
    word[A+16] := (word[A+16]<<16)/trunc(65536.0/detune)
    